Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 708)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 709)
@@ -1,8 +1,8 @@
  MODULE advec_ws
-
 
 !-----------------------------------------------------------------------------!
 ! Current revisions:
 ! -----------------
+! formatting adjustments
 !
 ! Former revisions:
@@ -44,5 +44,4 @@
 !-----------------------------------------------------------------------------!
 
-
     PRIVATE
     PUBLIC   advec_s_ws, advec_u_ws, advec_v_ws, advec_w_ws, &
@@ -52,23 +51,29 @@
        MODULE PROCEDURE ws_init
     END INTERFACE ws_init
+
     INTERFACE ws_statistics
        MODULE PROCEDURE ws_statistics
     END INTERFACE ws_statistics
+
     INTERFACE advec_s_ws
        MODULE PROCEDURE advec_s_ws
        MODULE PROCEDURE advec_s_ws_ij
     END INTERFACE advec_s_ws
+
     INTERFACE advec_u_ws
        MODULE PROCEDURE advec_u_ws
        MODULE PROCEDURE advec_u_ws_ij
     END INTERFACE advec_u_ws
+
     INTERFACE advec_v_ws
        MODULE PROCEDURE advec_v_ws
        MODULE PROCEDURE advec_v_ws_ij
     END INTERFACE advec_v_ws
+
     INTERFACE advec_w_ws
        MODULE PROCEDURE advec_w_ws
        MODULE PROCEDURE advec_w_ws_ij
     END INTERFACE advec_w_ws
+
     INTERFACE local_diss
        MODULE PROCEDURE local_diss
@@ -78,8 +83,10 @@
  CONTAINS
 
-!
-!-- Initialisation
-
+
+!------------------------------------------------------------------------------!
+! Initialization of WS-scheme
+!------------------------------------------------------------------------------!
     SUBROUTINE ws_init
+
        USE arrays_3d
        USE constants
@@ -91,15 +98,16 @@
 !--    Allocate arrays needed for dissipation control.
        IF ( dissipation_control )  THEN
-   !          ALLOCATE(var_x(nzb+1:nzt,nys:nyn,nxl:nxr),  &
-    !                  var_y(nzb+1:nzt,nys:nyn,nxl:nxr),  &
-     !                 var_z(nzb+1:nzt,nys:nyn,nxl:nxr),  &
-      !                gamma_x(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
-       !               gamma_y(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
-        !              gamma_z(nzb:nzt+1,nysg:nyng,nxlg:nxrg))
+!          ALLOCATE(var_x(nzb+1:nzt,nys:nyn,nxl:nxr),        &
+!                   var_y(nzb+1:nzt,nys:nyn,nxl:nxr),        &
+!                   var_z(nzb+1:nzt,nys:nyn,nxl:nxr),        &
+!                   gamma_x(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
+!                   gamma_y(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
+!                   gamma_z(nzb:nzt+1,nysg:nyng,nxlg:nxrg))
        ENDIF
-              
+
+!
 !--    Set the appropriate factors for scalar and momentum advection.
        adv_sca_5 = 0.016666666666666
-       adv_sca_3 = 0.083333333333333 
+       adv_sca_3 = 0.083333333333333
        adv_mom_5 = 0.0083333333333333
        adv_mom_3 = 0.041666666666666
@@ -108,10 +116,124 @@
 !--    Arrays needed for statical evaluation of fluxes.
        IF ( ws_scheme_mom )  THEN
-          ALLOCATE( sums_wsus_ws_l(nzb:nzt+1,0:statistic_regions),         &
-              sums_wsvs_ws_l(nzb:nzt+1,0:statistic_regions),               &
-              sums_us2_ws_l(nzb:nzt+1,0:statistic_regions),                &
-              sums_vs2_ws_l(nzb:nzt+1,0:statistic_regions),                &
-              sums_ws2_ws_l(nzb:nzt+1,0:statistic_regions))
-
+
+          ALLOCATE( sums_wsus_ws_l(nzb:nzt+1,0:statistic_regions),  &
+                    sums_wsvs_ws_l(nzb:nzt+1,0:statistic_regions),  &
+                    sums_us2_ws_l(nzb:nzt+1,0:statistic_regions),   &
+                    sums_vs2_ws_l(nzb:nzt+1,0:statistic_regions),   &
+                    sums_ws2_ws_l(nzb:nzt+1,0:statistic_regions))
+
+          sums_wsus_ws_l = 0.0
+          sums_wsvs_ws_l = 0.0
+          sums_us2_ws_l  = 0.0
+          sums_vs2_ws_l  = 0.0
+          sums_ws2_ws_l  = 0.0
+
+       ENDIF
+
+       IF ( ws_scheme_sca )  THEN
+
+          ALLOCATE( sums_wspts_ws_l(nzb:nzt+1,0:statistic_regions) )
+          sums_wspts_ws_l = 0.0
+
+          IF ( humidity .OR. passive_scalar )  THEN
+             ALLOCATE( sums_wsqs_ws_l(nzb:nzt+1,0:statistic_regions) )
+             sums_wsqs_ws_l = 0.0
+          ENDIF
+
+          IF ( ocean )  THEN
+             ALLOCATE( sums_wssas_ws_l(nzb:nzt+1,0:statistic_regions) )
+             sums_wssas_ws_l = 0.0
+          ENDIF
+
+       ENDIF
+
+!
+!--    Arrays needed for reasons of speed optimization for cache and noopt 
+!--    version. For the vector version the buffer arrays are not necessary, 
+!--    because the the fluxes can swapped directly inside the loops of the 
+!--    advection routines.
+       IF ( loop_optimization /= 'vector' )  THEN
+
+          IF ( ws_scheme_mom )  THEN
+
+             ALLOCATE( flux_s_u(nzb+1:nzt), flux_s_v(nzb+1:nzt),  &
+                       flux_s_w(nzb+1:nzt), diss_s_u(nzb+1:nzt),  &
+                       diss_s_v(nzb+1:nzt), diss_s_w(nzb+1:nzt) )
+             ALLOCATE( flux_l_u(nzb+1:nzt,nys:nyn),               &
+                       flux_l_v(nzb+1:nzt,nys:nyn),               &
+                       flux_l_w(nzb+1:nzt,nys:nyn),               &
+                       diss_l_u(nzb+1:nzt,nys:nyn),               &
+                       diss_l_v(nzb+1:nzt,nys:nyn),               &
+                       diss_l_w(nzb+1:nzt,nys:nyn) )
+
+          ENDIF
+
+          IF ( ws_scheme_sca )  THEN
+
+             ALLOCATE( flux_s_pt(nzb+1:nzt), flux_s_e(nzb+1:nzt), &
+                       diss_s_pt(nzb+1:nzt), diss_s_e(nzb+1:nzt) ) 
+             ALLOCATE( flux_l_pt(nzb+1:nzt,nys:nyn),              &
+                       flux_l_e(nzb+1:nzt,nys:nyn),               &
+                       diss_l_pt(nzb+1:nzt,nys:nyn),              &
+                       diss_l_e(nzb+1:nzt,nys:nyn) )
+
+             IF ( humidity .OR. passive_scalar )  THEN
+                ALLOCATE( flux_s_q(nzb+1:nzt), diss_s_q(nzb+1:nzt) )
+                ALLOCATE( flux_l_q(nzb+1:nzt,nys:nyn),            &
+                          diss_l_q(nzb+1:nzt,nys:nyn) )
+             ENDIF
+
+             IF ( ocean )  THEN
+                ALLOCATE( flux_s_sa(nzb+1:nzt), diss_s_sa(nzb+1:nzt) )
+                ALLOCATE( flux_l_sa(nzb+1:nzt,nys:nyn),           &
+                          diss_l_sa(nzb+1:nzt,nys:nyn) )
+             ENDIF
+
+          ENDIF
+
+       ENDIF
+
+!
+!--    Determine the flags where the order of the scheme for horizontal 
+!--    advection has to be degraded.
+       ALLOCATE( boundary_flags(nys:nyn,nxl:nxr) )
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+
+             boundary_flags(j,i) = 0
+             IF ( outflow_l )  THEN
+                IF ( i == nxlu  )  boundary_flags(j,i) = 5
+                IF ( i == nxl   )  boundary_flags(j,i) = 6
+             ELSEIF ( outflow_r )  THEN
+                IF ( i == nxr-1 )  boundary_flags(j,i) = 1
+                IF ( i == nxr   )  boundary_flags(j,i) = 2
+             ELSEIF ( outflow_n )  THEN
+                IF ( j == nyn-1 )  boundary_flags(j,i) = 3
+                IF ( j == nyn   )  boundary_flags(j,i) = 4
+             ELSEIF ( outflow_s )  THEN
+                IF ( j == nysv  )  boundary_flags(j,i) = 7
+                IF ( j == nys   )  boundary_flags(j,i) = 8
+             ENDIF
+
+          ENDDO
+       ENDDO
+       
+    END SUBROUTINE ws_init
+
+
+!------------------------------------------------------------------------------!
+! Initialize variables used for storing statistic qauntities (fluxes, variances)
+!------------------------------------------------------------------------------!
+    SUBROUTINE ws_statistics
+    
+       USE control_parameters
+       USE statistics
+
+       IMPLICIT NONE
+
+!       
+!--    The arrays needed for statistical evaluation are set to to 0 at the 
+!--    begin of prognostic_equations.
+       IF ( ws_scheme_mom )  THEN
           sums_wsus_ws_l = 0.0
           sums_wsvs_ws_l = 0.0
@@ -122,98 +244,11 @@
 
        IF ( ws_scheme_sca )  THEN
-          ALLOCATE( sums_wspts_ws_l(nzb:nzt+1,0:statistic_regions))
           sums_wspts_ws_l = 0.0
-          IF ( humidity  .OR.  passive_scalar )  THEN
-             ALLOCATE( sums_wsqs_ws_l(nzb:nzt+1,0:statistic_regions))
-             sums_wsqs_ws_l = 0.0
-          ENDIF
-          IF ( ocean )  THEN
-             ALLOCATE( sums_wssas_ws_l(nzb:nzt+1,0:statistic_regions))
-             sums_wssas_ws_l = 0.0
-          ENDIF
+          IF ( humidity .OR. passive_scalar )  sums_wsqs_ws_l = 0.0
+          IF ( ocean )  sums_wssas_ws_l = 0.0
+
        ENDIF
-!
-!--    Arrays needed for reasons of speed optimization for cache and noopt 
-!--    version. For the vector version the buffer arrays are not necessary, 
-!--    because the the fluxes can swapped directly inside the loops of the 
-!--    advection routines.
-       IF ( loop_optimization /= 'vector' )  THEN
-          IF ( ws_scheme_mom )  THEN
-             ALLOCATE(flux_s_u(nzb+1:nzt), flux_s_v(nzb+1:nzt),            &
-                flux_s_w(nzb+1:nzt), diss_s_u(nzb+1:nzt),                  &
-                diss_s_v(nzb+1:nzt), diss_s_w(nzb+1:nzt))
-             ALLOCATE(flux_l_u(nzb+1:nzt,nys:nyn),                         &
-                flux_l_v(nzb+1:nzt,nys:nyn), flux_l_w(nzb+1:nzt,nys:nyn),  & 
-                diss_l_u(nzb+1:nzt,nys:nyn), diss_l_v(nzb+1:nzt,nys:nyn),  & 
-                diss_l_w(nzb+1:nzt,nys:nyn)) 
-          ENDIF
-          IF ( ws_scheme_sca )  THEN
-             ALLOCATE(flux_s_pt(nzb+1:nzt), flux_s_e(nzb+1:nzt),           &
-                diss_s_pt(nzb+1:nzt), diss_s_e(nzb+1:nzt))
-             ALLOCATE(flux_l_pt(nzb+1:nzt,nys:nyn),                        &
-                flux_l_e(nzb+1:nzt,nys:nyn), diss_l_pt(nzb+1:nzt,nys:nyn), & 
-                diss_l_e(nzb+1:nzt,nys:nyn))
-             IF ( humidity  .OR.  passive_scalar )  THEN
-                ALLOCATE(flux_s_q(nzb+1:nzt), diss_s_q(nzb+1:nzt))
-                ALLOCATE(flux_l_q(nzb+1:nzt,nys:nyn),                      &
-                   diss_l_q(nzb+1:nzt,nys:nyn))
-             ENDIF
-             IF ( ocean )  THEN
-                ALLOCATE(flux_s_sa(nzb+1:nzt), diss_s_sa(nzb+1:nzt))
-                ALLOCATE(flux_l_sa(nzb+1:nzt,nys:nyn),                     &
-                   diss_l_sa(nzb+1:nzt,nys:nyn))
-             ENDIF
-          ENDIF
-       ENDIF
-!
-!--    Determine the flags where the order of the scheme for horizontal 
-!--    advection should be degraded.
-       ALLOCATE( boundary_flags(nys:nyn,nxl:nxr) )
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             boundary_flags(j,i) = 0
-             IF ( outflow_l )  THEN
-                IF ( i == nxlu )  boundary_flags(j,i) = 5
-                IF ( i == nxl )  boundary_flags(j,i) = 6
-             ELSEIF ( outflow_r )  THEN
-                IF ( i == nxr-1 )  boundary_flags(j,i) = 1
-                IF ( i == nxr )  boundary_flags(j,i) = 2
-             ELSEIF ( outflow_n )  THEN
-                IF ( j == nyn-1 )  boundary_flags(j,i) = 3
-                IF ( j == nyn )  boundary_flags(j,i) = 4
-             ELSEIF ( outflow_s )  THEN
-                IF ( j == nysv )  boundary_flags(j,i) = 7
-                IF ( j == nys )  boundary_flags(j,i) = 8
-             ENDIF
-          ENDDO
-       ENDDO
-       
-    END SUBROUTINE ws_init
-    
-
-    
-    SUBROUTINE ws_statistics
-    
-       USE control_parameters
-       USE statistics
-
-!       
-!--      The arrays needed for statistical evaluation are set to to 0 at the 
-!--      begin of prognostic_equations.
-          IF ( ws_scheme_mom )  THEN
-             sums_wsus_ws_l = 0.0
-             sums_wsvs_ws_l = 0.0
-             sums_us2_ws_l = 0.0
-             sums_vs2_ws_l = 0.0
-             sums_ws2_ws_l = 0.0
-          ENDIF
-          IF ( ws_scheme_sca )  THEN
-             sums_wspts_ws_l = 0.0
-             IF ( humidity  .OR.  passive_scalar )  sums_wsqs_ws_l = 0.0
-             IF ( ocean )  sums_wssas_ws_l = 0.0
-          ENDIF
 
     END SUBROUTINE ws_statistics
-
 
 
@@ -222,5 +257,6 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE advec_s_ws_ij( i, j, sk, sk_char,swap_flux_y_local,  &
-               swap_diss_y_local, swap_flux_x_local, swap_diss_x_local  )
+                              swap_diss_y_local, swap_flux_x_local, &
+                              swap_diss_x_local  )
 
        USE arrays_3d
@@ -239,10 +275,11 @@
        REAL, DIMENSION(nzb:nzt+1)         :: flux_t, diss_t, flux_r, diss_r,  &
                                              flux_n, diss_n
-       REAL, DIMENSION(nzb+1:nzt)         :: swap_flux_y_local,               &       
+       REAL, DIMENSION(nzb+1:nzt)         :: swap_flux_y_local,               &
                                              swap_diss_y_local
        REAL, DIMENSION(nzb+1:nzt,nys:nyn) :: swap_flux_x_local,               &
                                              swap_diss_x_local
        CHARACTER (LEN = *), INTENT(IN)    :: sk_char
-       
+
+
        degraded_l = .FALSE.
        degraded_s = .FALSE.
